Package: trackopt
Type: Package
Title: Track Numerical Optimization
Version: 0.1.1
Authors@R: 
    person(
        "Lennart", "Oelschl\u00e4ger",
        email = "oelschlaeger.lennart@gmail.com",
        role = c("aut", "cre")
    )
Description: Tracks parameter values, gradients, and Hessians at each
    iteration of numerical optimizers. Useful for analyzing optimization
    progress, diagnosing issues, and studying convergence behavior.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: checkmate, cli, ggplot2, oeli (>= 0.7.2), optimizeR (>=
        1.2.0), stats, tibble, utils
Suggests: testthat (>= 3.0.0)
Depends: R (>= 4.1.0)
Config/testthat/edition: 3
URL: https://github.com/loelschlaeger/trackopt
BugReports: https://github.com/loelschlaeger/trackopt/issues
NeedsCompilation: no
Packaged: 2026-05-12 15:52:33 UTC; Lennart Oelschläger
Author: Lennart Oelschläger [aut, cre]
Maintainer: Lennart Oelschläger <oelschlaeger.lennart@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-12 18:40:09 UTC
Built: R 4.6.0; ; 2026-05-12 21:43:32 UTC; unix

Package: trackopt
Type: Package
Title: Track Numerical Optimization
Version: 0.1.1
Authors@R: 
    person(
        "Lennart", "Oelschl\u00e4ger",
        email = "oelschlaeger.lennart@gmail.com",
        role = c("aut", "cre")
    )
Description: Tracks parameter values, gradients, and Hessians at each
    iteration of numerical optimizers. Useful for analyzing optimization
    progress, diagnosing issues, and studying convergence behavior.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 7.3.3
Imports: checkmate, cli, ggplot2, oeli (>= 0.7.2), optimizeR (>=
        1.2.0), stats, tibble, utils
Suggests: testthat (>= 3.0.0)
Depends: R (>= 4.1.0)
Config/testthat/edition: 3
URL: https://github.com/loelschlaeger/trackopt
BugReports: https://github.com/loelschlaeger/trackopt/issues
NeedsCompilation: no
Packaged: 2026-05-12 15:52:33 UTC; Lennart Oelschläger
Author: Lennart Oelschläger [aut, cre]
Maintainer: Lennart Oelschläger <oelschlaeger.lennart@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-12 18:40:09 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# Track numerical optimization <a href="https://loelschlaeger.de/trackopt/"><img src="man/figures/logo.png" align="right" height="124" alt="trackopt website" /></a>

<!-- badges: start -->

[![CRAN
status](https://www.r-pkg.org/badges/version/trackopt)](https://CRAN.R-project.org/package=trackopt)
[![CRAN
downloads](https://cranlogs.r-pkg.org/badges/grand-total/trackopt)](https://CRAN.R-project.org/package=trackopt)
[![R-CMD-check](https://github.com/loelschlaeger/trackopt/workflows/R-CMD-check/badge.svg)](https://github.com/loelschlaeger/trackopt/actions)
[![Codecov test
coverage](https://codecov.io/gh/loelschlaeger/trackopt/branch/master/graph/badge.svg)](https://app.codecov.io/gh/loelschlaeger/trackopt?branch=master)
<!-- badges: end -->

The `{trackopt}` package tracks parameter values, gradients, and
Hessians at each iteration of numerical optimizers in `R`. This can be
useful for analyzing optimization progress, diagnosing issues, and
studying convergence behavior.

## Installation

You can install the released package version from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("trackopt")
```

## Examples

The following example tracks `nlm` while it minimizes [Himmelblau’s
function](https://en.wikipedia.org/wiki/Himmelblau%27s_function):

``` r
library("trackopt")
himmelblau <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
track <- nlm_track(f = himmelblau, p = c(0, 0))
summary(track)
#> Iterations: 16
#> Function improvement: 170 -> 1.521e-07
#> Computation time: 0.07373 seconds
#> Initial parameter: 0, 0
#> Final parameter: 3, 2
ggplot2::autoplot(track)
```

<img src="man/figures/README-himmelblau-1.png" alt="" width="100%" />

The next example tracks `optim` while it minimizes a quartic polynomial:

``` r
polynomial <- function(x) 5 * x^4 + 4 * x^3 + x^2 + 3 * x + 2
gradient <- function(x) 20 * x^3 + 12 * x^2 + 2 * x + 3
track <- optim_track(
  f = polynomial,
  p = 0,
  gradient = gradient,
  method = "BFGS"
)
print(track)
#> # A tibble: 9 × 6
#>   iteration value         step parameter hessian seconds
#> *     <dbl> <dbl>        <dbl>     <dbl>   <dbl>   <dbl>
#> 1         0 2      0               0       NA    0      
#> 2         1 0.344 -1.66           -0.6      9.20 0.00830
#> 3         2 0.241 -0.103          -0.672   13.0  0.00156
#> 4         3 0.212 -0.0293         -0.712   15.3  0.00144
#> 5         4 0.207 -0.00524        -0.730   16.4  0.00144
#> 6         5 0.206 -0.000679       -0.736   16.8  0.00143
#> 7         6 0.206 -0.0000752      -0.738   17.0  0.00271
#> 8         7 0.206 -0.00000784     -0.739   17.0  0.00151
#> 9         8 0.206 -0.000000802    -0.739   17.0  0.00147
ggplot2::autoplot(track)
```

<img src="man/figures/README-polynomial-1.png" alt="" width="100%" />

## Contact

If you have questions, find a bug, or need a feature, please [file an
issue on
GitHub](https://github.com/loelschlaeger/trackopt/issues/new/choose).

#' @rdname nlm_track
#'
#' @param lower,upper \[`numeric()` | `NULL`\]\cr
#' Optional lower and upper parameter bounds. Scalars are recycled to the
#' number of parameters.
#'
#' @param method,control
#' Arguments passed on to \code{\link[stats]{optim}}.
#'
#' Elements `trace` and `maxit` are ignored in `control` because
#' `optim_track()` controls tracing and iteration limits directly.
#'
#' @export

optim_track <- function(
    f, p, target = NULL, npar = NULL, gradient = NULL,
    ..., iterations_max = 100, tolerance = 1e-6,
    lower = NULL, upper = NULL,
    method = c("Nelder-Mead", "BFGS", "CG", "L-BFGS-B", "SANN", "Brent"),
    control = list(), minimize = TRUE, verbose = FALSE
) {

  ### input checks and building of objects
  oeli::input_check_response(
    check = oeli::check_missing(f),
    var_name = "f"
  )
  oeli::input_check_response(
    check = oeli::check_missing(p),
    var_name = "p"
  )
  oeli::input_check_response(
    check = oeli::check_numeric_vector(p, any.missing = FALSE),
    var_name = "p"
  )
  if (is.null(npar)) {
    npar <- length(p)
  }
  objective <- optimizeR::Objective$new(
    f = f,
    target = target,
    npar = npar,
    ...
  )
  if (!is.null(gradient)) {
    oeli::input_check_response(
      check = checkmate::check_function(gradient),
      var_name = "gradient"
    )
    objective$set_gradient(gradient = gradient, .verbose = FALSE)
  }
  npar <- sum(objective$npar)
  oeli::input_check_response(
    check = oeli::check_numeric_vector(p, len = npar),
    var_name = "p"
  )
  oeli::input_check_response(
    check = checkmate::check_count(iterations_max, positive = FALSE),
    var_name = "iterations_max"
  )
  oeli::input_check_response(
    check = checkmate::check_number(tolerance, lower = 0),
    var_name = "tolerance"
  )
  if (!is.null(lower)) {
    if (length(lower) == 1) {
      lower <- rep(lower, npar)
    }
    oeli::input_check_response(
      check = oeli::check_numeric_vector(lower, len = npar),
      var_name = "lower"
    )
    oeli::input_check_response(
      check = if (any(p < lower)) "Must respect lower limit" else TRUE,
      var_name = "p"
    )
  }
  oeli::input_check_response(
    check = oeli::check_numeric_vector(
      upper,
      any.missing = FALSE,
      null.ok = TRUE
    ),
    var_name = "upper"
  )
  if (!is.null(upper)) {
    if (length(upper) == 1) {
      upper <- rep(upper, npar)
    }
    oeli::input_check_response(
      check = oeli::check_numeric_vector(upper, len = npar),
      var_name = "upper"
    )
    oeli::input_check_response(
      check = if (any(p > upper)) "Must respect upper limit" else TRUE,
      var_name = "p"
    )
  }
  oeli::input_check_response(
    check = checkmate::check_list(control, names = "strict"),
    var_name = "control"
  )
  control[["maxit"]] <- 1
  control[["trace"]] <- NULL
  optimizer <- optimizeR::Optimizer$new(
    which = "stats::optim",
    method = method, control = control, hessian = TRUE,
    .verbose = FALSE
  )
  oeli::input_check_response(
    check = checkmate::check_flag(minimize),
    var_name = "minimize"
  )
  oeli::input_check_response(
    check = checkmate::check_flag(verbose),
    var_name = "verbose"
  )

  ### start values
  if (verbose) {
    cli::cli_h1("Start tracing {.fun optim}")
    cli::cli_h3("Iteration {0}")
  }
  current_initial <- p
  current_value <- objective$evaluate(.at = p)
  current_step <- 0
  oeli::input_check_response(
    check = checkmate::check_number(current_value, finite = TRUE),
    prefix = "{.fun {objective$objective_name}} evaluated at {.var p} is bad:"
  )
  if (verbose) {
    cli::cat_line("Step:")
    cli::cat_print(current_step)
    cli::cat_line("Parameter:")
    cli::cat_print(current_initial)
    cli::cat_line("Function value:")
    cli::cat_print(current_value)
  }

  ### prepare output tibble
  current_hessian <- if (isTRUE(objective$hessian_specified)) {
    objective$evaluate_hessian(.at = p)
  } else {
    NA_real_
  }
  out <- tibble::tibble(iteration = 0) |>
    assign_to_cell(1, "value", current_value) |>
    assign_to_cell(1, "step", current_step) |>
    assign_to_cell(1, "parameter", p) |>
    assign_to_cell(1, "hessian", current_hessian) |>
    assign_to_cell(1, "seconds", 0)

  ### start optimization
  for (i in seq_len(iterations_max)) {

    ### progress status
    if (verbose) {
      cli::cli_h3("Iteration {i}")
    }

    ### one iteration ahead
    step <- optimizer$optimize(
      objective = objective,
      initial = current_initial,
      lower = if (!is.null(lower)) lower else NA,
      upper = if (!is.null(upper)) upper else NA,
      direction = ifelse(minimize, "min", "max")
    )
    current_step <- step$value - current_value

    ### progress status
    if (verbose) {
      cli::cat_line("Step:")
      cli::cat_print(current_step)
      cli::cat_line("Parameter:")
      cli::cat_print(current_initial)
      cli::cat_line("Function value:")
      cli::cat_print(current_value)
    }

    ### save results
    out <- out |>
      assign_to_cell(i + 1, "iteration", i) |>
      assign_to_cell(i + 1, "value", step$value) |>
      assign_to_cell(i + 1, "step", current_step) |>
      assign_to_cell(i + 1, "parameter", step$parameter) |>
      assign_to_cell(i + 1, "hessian", step$hessian) |>
      assign_to_cell(i + 1, "seconds", step$seconds)

    ### check termination
    if (isTRUE(step$error)) {
      cli::cli_warn("Optimization failed: {step$error_message}")
      if (verbose) {
        cli::cli_h3("Termination")
        cli::cli_alert_warning("An error occurred")
        cli::cli_alert_info("{step$error_message}")
      }
      break
    }
    if (abs(current_step) < tolerance) {
      if (verbose) {
        cli::cli_h3("Termination")
        cli::cli_alert_success(
          "Absolute change in function value < {tolerance}"
        )
      }
      break
    }
    if (i == iterations_max && verbose) {
      cli::cli_h3("Termination")
      cli::cli_alert_warning("Iteration limit of {iterations_max} reached")
    }

    ### new start values
    current_initial <- step$parameter
    current_value <- step$value
  }

  ### return
  structure(
    out,
    class = c("trackopt", class(out)),
    objective = objective,
    npar = npar
  )
}

test_that("one-dim optim track works", {
  f <- function(x) 5*x^4 + 4*x^3 + x^2 + 3*x + 2
  gradient <- function(x) 20*x^3 + 12*x^2 + 2*x + 3
  track <- optim_track(
    f = f,
    p = 5,
    gradient = gradient,
    method = "Brent",
    lower = -10,
    upper = 10
  )
  checkmate::expect_tibble(track, ncols = 6)
  checkmate::expect_class(summary(track), "summary.trackopt")
  checkmate::expect_class(invisible(autoplot(track)), "ggplot")
})

test_that("two-dim optim track works", {
  himmelblau <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
  oeli::quiet(
    track <- optim_track(f = himmelblau, p = c(0, 0), verbose = TRUE)
  )
  checkmate::expect_tibble(track, ncols = 6)
  checkmate::expect_class(summary(track), "summary.trackopt")
  checkmate::expect_class(invisible(autoplot(track)), "ggplot")
})

#' @rdname nlm_track
#' @exportS3Method summary trackopt

summary.trackopt <- function(object, ...) {

  ### input checks
  oeli::input_check_response(
    check = oeli::check_missing(object),
    var_name = "object"
  )
  oeli::input_check_response(
    check = checkmate::check_class(object, "trackopt"),
    var_name = "object"
  )
  oeli::input_check_response(
    check = checkmate::check_tibble(object, min.rows = 1, min.cols = 1),
    var_name = "object"
  )

  ### build summary
  n <- nrow(object)
  summary <- list(
    "iterations" = n - 1,
    "start_value" = object[[1, "value"]],
    "end_value" = object[[n, "value"]],
    "seconds_total" = sum(object[["seconds"]], na.rm = TRUE),
    "start_parameter" = object[[1, "parameter"]][[1]],
    "end_parameter" = object[[n, "parameter"]][[1]]
  )

  ### return
  structure(summary, class = c("summary.trackopt", "list"))

}

#' @keywords internal
#' @exportS3Method print summary.trackopt

print.summary.trackopt <- function(x, ...) {
  value_change <- sprintf("%.4g -> %.4g", x$start_value, x$end_value)
  initial_parameter <- paste(
    sprintf("%.4g", x$start_parameter),
    collapse = ", "
  )
  final_parameter <- paste(
    sprintf("%.4g", x$end_parameter),
    collapse = ", "
  )
  cli::cat_line(
    "Iterations: ", x$iterations,
    "\nFunction improvement: ", value_change,
    "\nComputation time: ", sprintf("%.4g seconds", x$seconds_total),
    "\nInitial parameter: ", initial_parameter,
    "\nFinal parameter: ", final_parameter
  )
  invisible(x)
}

#' @rdname nlm_track
#'
#' @param xlim,xlim2 \[`numeric(2)`\]\cr
#' Ranges for the first and second parameter to plot.
#'
#' If `NULL`, they are derived from the parameter ranges in `object`.
#'
#' @param iteration \[`integer(1)`\]\cr
#' The iteration to plot.
#'
#' If `NULL`, the last iteration is plotted.
#'
#' This option is useful for creating animations with the R Markdown
#' `animation` chunk option.
#'
#' @export

autoplot.trackopt <- function(
    object, iteration = NULL, xlim = NULL, xlim2 = NULL, ...
  ) {

  ### input checks
  oeli::input_check_response(
    check = oeli::check_missing(object),
    var_name = "object"
  )
  oeli::input_check_response(
    check = checkmate::check_class(object, "trackopt"),
    var_name = "object"
  )
  npar <- attr(object, "npar")
  oeli::input_check_response(
    check = checkmate::check_count(npar, positive = TRUE),
    prefix = "Attribute {.var npar} of {.var object} is bad:"
  )
  iterations <- object$iteration
  oeli::input_check_response(
    check = checkmate::check_integerish(
      iterations, lower = 0, any.missing = FALSE, min.len = 0, unique = TRUE,
      sorted = TRUE
    ),
    prefix = "Element {.var object$iteration} is bad:"
  )
  if (is.null(iteration)) {
    iteration <- max(iterations)
  }
  oeli::input_check_response(
    check = checkmate::check_int(
      iteration,
      lower = 0,
      upper = max(iterations)
    ),
    var_name = "iteration"
  )
  oeli::input_check_response(
    check = checkmate::check_numeric(
      xlim, any.missing = FALSE, len = 2, sorted = TRUE, null.ok = TRUE,
      finite = TRUE
    ),
    var_name = "xlim"
  )
  oeli::input_check_response(
    check = checkmate::check_numeric(
      xlim2, any.missing = FALSE, len = 2, sorted = TRUE, null.ok = TRUE,
      finite = TRUE
    ),
    var_name = "xlim2"
  )

  ### call 1D or 2D autoplot
  if (npar == 1) {
    autoplot_trackopt_1d(
      object,
      iteration = iteration,
      xlim = xlim,
      ...
    )
  } else if (npar == 2) {
    autoplot_trackopt_2d(
      object,
      iteration = iteration,
      xlim = xlim,
      xlim2 = xlim2,
      ...
    )
  } else {
    cli::cli_warn("Currently not available for more than two parameters")
    return(NULL)
  }

}

#' @keywords internal
#' @noRd

autoplot_trackopt_1d <- function(object, iteration, xlim, ...) {
  if (is.null(xlim)) {
    range <- range(object$parameter)
    xlim <- c(floor(range[1]), ceiling(range[2]))
  }
  objective <- attr(object, "objective")
  objective_name <- objective$objective_name
  target_name <- objective$target
  f <- function(x) objective$evaluate(x)
  data <- object[seq_len(iteration + 1), ]
  iteration_info <- paste("Iteration:", iteration)
  gradient_value <- data[[iteration + 1, "gradient"]]
  gradient_info <- NULL
  hessian_info <- NULL
  if (checkmate::test_number(gradient_value)) {
    gradient_value <- format(
      round(gradient_value, 2),
      scientific = FALSE
    )
    gradient_info <- paste("\nGradient:", gradient_value)
    hessian_value <- data[[iteration + 1, "hessian"]]
    if (checkmate::test_number(hessian_value)) {
      hessian_value <- format(
        round(hessian_value, 2),
        scientific = FALSE
      )
      hessian_info <- paste("\nHessian:", hessian_value)
    }
  }
  ggplot2::ggplot(
    data = data,
    mapping = ggplot2::aes(x = parameter, y = value)
  ) +
    ggplot2::geom_function(fun = function(x) sapply(x, f), xlim = xlim) +
    ggplot2::geom_point(color = "red", size = 2) +
    ggplot2::geom_path(color = "red") +
    ggplot2::scale_x_continuous(limits = xlim) +
    ggplot2::labs(
      x = target_name,
      y = paste0(objective_name, "(", target_name, ")"),
      title = "Optimization path",
      subtitle = paste(iteration_info, gradient_info, hessian_info)
    )
}

#' @keywords internal
#' @noRd

autoplot_trackopt_2d <- function(object, iteration, xlim, xlim2, ...) {
  if (is.null(xlim)) {
    range <- range(sapply(object$parameter, `[`, 1))
    xlim <- c(floor(range[1]), ceiling(range[2]))
  }
  if (is.null(xlim2)) {
    range <- range(sapply(object$parameter, `[`, 2))
    xlim2 <- c(floor(range[1]), ceiling(range[2]))
  }
  objective <- attr(object, "objective")
  objective_name <- objective$objective_name
  target_name <- objective$target
  f <- function(x, y) objective$evaluate(c(x, y))
  data <- object[seq_len(iteration + 1), ]
  x_seq <- seq(xlim[1], xlim[2], length.out = 100)
  y_seq <- seq(xlim2[1], xlim2[2], length.out = 100)
  grid <- expand.grid(x = x_seq, y = y_seq)
  grid$z <- apply(grid, 1, function(row) f(row["x"], row["y"]))
  param_matrix <- do.call(rbind, data$parameter)
  data_plot <- data.frame(
    x = param_matrix[, 1],
    y = param_matrix[, 2],
    value = data$value
  )
  iteration_info <- paste("Iteration:", iteration)
  gradient_info <- NULL
  hessian_info <- NULL
  gradient_value <- data[[iteration + 1, "gradient"]]
  if (checkmate::test_numeric(gradient_value, len = 2)) {
    grad_norm <- sqrt(sum(gradient_value^2))
    grad_norm <- format(
      round(grad_norm, 2),
      scientific = FALSE
    )
    gradient_info <- paste("\nGradient norm:", grad_norm)
    hessian_value <- data[[iteration + 1, "hessian"]]
    if (checkmate::test_matrix(hessian_value, nrows = 2, ncols = 2)) {
      hessian_det <- format(
        round(det(hessian_value), 2),
        scientific = FALSE
      )
      hessian_info <- paste("\nHessian determinant:", hessian_det)
    }
  }
  ggplot2::ggplot(data = data_plot, mapping = ggplot2::aes(x = x, y = y)) +
    ggplot2::geom_contour_filled(data = grid, aes(x = x, y = y, z = z)) +
    ggplot2::geom_point() +
    ggplot2::geom_path() +
    ggplot2::scale_x_continuous(limits = xlim) +
    ggplot2::scale_y_continuous(limits = xlim2) +
    ggplot2::labs(
      x = paste0(target_name, "[1]"),
      y = paste0(target_name, "[2]"),
      fill = paste0(objective_name, "(", target_name, ")"),
      title = "Optimization path",
      subtitle = paste(iteration_info, gradient_info, hessian_info)
    )
}

#' Track numerical optimization
#'
#' @description
#' - `nlm_track()`: track \code{\link[stats]{nlm}} iterations
#' - `optim_track()`: track \code{\link[stats]{optim}} iterations
#' - `summary()`: summarize an optimization track
#' - `autoplot()`: visualize a track with one or two parameters
#'
#' @param f \[`function`\]\cr
#' A `function` to optimize. It must return a single `numeric` value.
#'
#' By default, the first argument of `f` is optimized. That argument should
#' be a `numeric` vector of the same length as `p`. Additional arguments can
#' be supplied through `...`.
#'
#' Use `target` when `f` should be optimized over another argument or over
#' multiple arguments.
#'
#' @param p \[`numeric()`\]\cr
#' The starting parameter values for the target argument(s).
#'
#' @param target \[`character()` | `NULL`\]\cr
#' The names of the numeric argument(s) to optimize.
#'
#' If `NULL` (default), the first argument of `f` is used.
#'
#' @param npar \[`integer()`\]\cr
#' The length of each target argument.
#'
#' Specify `npar` when optimizing over multiple target arguments so `p` can
#' be split correctly.
#'
#' If `target` contains a single argument and `npar` is `NULL`, `length(p)`
#' is used.
#'
#' @param gradient \[`function` | `NULL`\]\cr
#' Optionally a `function` that returns the gradient of `f`.
#'
#' Its arguments must match the arguments of `f`.
#'
#' @param hessian \[`function` | `NULL`\]\cr
#' Optionally a `function` that returns the Hessian of `f`.
#'
#' Its arguments must match the arguments of `f`.
#'
#' @param ...
#' Additional arguments passed to `f`, and to `gradient` and `hessian` when
#' they are specified.
#'
#' @param iterations_max \[`integer(1)`\]\cr
#' The maximum number of tracked optimization steps before termination.
#'
#' @param tolerance \[`numeric(1)`\]\cr
#' Tracking stops when the absolute change in function value between two
#' consecutive iterations is less than this value.
#'
#' @param typsize,fscale,ndigit,stepmax,steptol
#' Arguments passed on to \code{\link[stats]{nlm}}.
#'
#' @param minimize \[`logical(1)`\]\cr
#' If `TRUE`, minimize `f`; otherwise maximize it.
#'
#' @param verbose \[`logical(1)`\]\cr
#' If `TRUE`, print progress after each iteration.
#'
#' @param object \[`trackopt`\]\cr
#' A `trackopt` object.
#'
#' @return
#' A `tibble` with one row per stored iteration, including the starting point.
#'
#' @export
#'
#' @examples
#' himmelblau <- function(x) {
#'   (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
#' }
#' track <- nlm_track(f = himmelblau, p = c(0, 0))
#' summary(track)
#' ggplot2::autoplot(track)

nlm_track <- function(
    f, p, target = NULL, npar = NULL, gradient = NULL, hessian = NULL,
    ..., iterations_max = 100, tolerance = 1e-6,
    typsize = rep(1, length(p)), fscale = 1, ndigit = 12,
    stepmax = max(1000 * sqrt(sum((p/typsize)^2)), 1000), steptol = 1e-6,
    minimize = TRUE, verbose = FALSE
  ) {

  ### input checks and building of objects
  oeli::input_check_response(
    check = oeli::check_missing(f),
    var_name = "f"
  )
  oeli::input_check_response(
    check = oeli::check_missing(p),
    var_name = "p"
  )
  oeli::input_check_response(
    check = oeli::check_numeric_vector(p, any.missing = FALSE),
    var_name = "p"
  )
  if (is.null(npar)) {
    npar <- length(p)
  }
  objective <- optimizeR::Objective$new(
    f = f,
    target = target,
    npar = npar,
    ...
  )
  if (!is.null(gradient)) {
    oeli::input_check_response(
      check = checkmate::check_function(gradient),
      var_name = "gradient"
    )
    objective$set_gradient(gradient = gradient, .verbose = FALSE)
  }
  if (!is.null(hessian)) {
    oeli::input_check_response(
      check = checkmate::check_function(hessian),
      var_name = "hessian"
    )
    objective$set_hessian(hessian = hessian, .verbose = FALSE)
  }
  npar <- sum(objective$npar)
  oeli::input_check_response(
    check = oeli::check_numeric_vector(p, len = npar),
    var_name = "p"
  )
  oeli::input_check_response(
    check = checkmate::check_count(iterations_max, positive = FALSE),
    var_name = "iterations_max"
  )
  oeli::input_check_response(
    check = checkmate::check_number(tolerance, lower = 0),
    var_name = "tolerance"
  )
  optimizer <- optimizeR::Optimizer$new(
    which = "stats::nlm",
    typsize = typsize, fscale = fscale, ndigit = ndigit, stepmax = stepmax,
    steptol = steptol, iterlim = 1, hessian = TRUE,
    .verbose = FALSE
  )
  oeli::input_check_response(
    check = checkmate::check_flag(minimize),
    var_name = "minimize"
  )
  oeli::input_check_response(
    check = checkmate::check_flag(verbose),
    var_name = "verbose"
  )

  ### start values
  if (verbose) {
    cli::cli_h1("Start tracing {.fun nlm}")
    cli::cli_h3("Iteration {0}")
  }
  current_initial <- p
  current_value <- objective$evaluate(.at = p)
  current_step <- 0
  oeli::input_check_response(
    check = checkmate::check_number(current_value, finite = TRUE),
    prefix = "{.fun {objective$objective_name}} evaluated at {.var p} is bad:"
  )
  if (verbose) {
    cli::cat_line("Step:")
    cli::cat_print(current_step)
    cli::cat_line("Parameter:")
    cli::cat_print(current_initial)
    cli::cat_line("Function value:")
    cli::cat_print(current_value)
  }

  ### prepare output tibble
  current_gradient <- if (isTRUE(objective$gradient_specified)) {
    objective$evaluate_gradient(.at = p)
  } else {
    NA_real_
  }
  current_hessian <- if (isTRUE(objective$hessian_specified)) {
    objective$evaluate_hessian(.at = p)
  } else {
    NA_real_
  }
  out <- tibble::tibble(iteration = 0) |>
    assign_to_cell(1, "value", current_value) |>
    assign_to_cell(1, "step", current_step) |>
    assign_to_cell(1, "parameter", p) |>
    assign_to_cell(1, "gradient", current_gradient) |>
    assign_to_cell(1, "hessian", current_hessian) |>
    assign_to_cell(1, "seconds", 0)

  ### start optimization
  for (i in seq_len(iterations_max)) {

    ### progress status
    if (verbose) {
      cli::cli_h3("Iteration {i}")
    }

    ### one iteration ahead
    step <- optimizer$optimize(
      objective = objective,
      initial = current_initial,
      direction = ifelse(minimize, "min", "max")
    )
    current_step <- step$value - current_value

    ### progress status
    if (verbose) {
      cli::cat_line("Step:")
      cli::cat_print(current_step)
      cli::cat_line("Parameter:")
      cli::cat_print(current_initial)
      cli::cat_line("Function value:")
      cli::cat_print(current_value)
    }

    ### save results
    out <- out |>
      assign_to_cell(i + 1, "iteration", i) |>
      assign_to_cell(i + 1, "value", step$value) |>
      assign_to_cell(i + 1, "step", current_step) |>
      assign_to_cell(i + 1, "parameter", step$parameter) |>
      assign_to_cell(i + 1, "gradient", step$gradient) |>
      assign_to_cell(i + 1, "hessian", step$hessian) |>
      assign_to_cell(i + 1, "seconds", step$seconds)

    ### check termination
    if (isTRUE(step$error)) {
      cli::cli_warn("Optimization failed: {step$error_message}")
      if (verbose) {
        cli::cli_h3("Termination")
        cli::cli_alert_warning("An error occurred")
        cli::cli_alert_info("{step$error_message}")
      }
      break
    }
    if (abs(current_step) < tolerance) {
      if (verbose) {
        cli::cli_h3("Termination")
        cli::cli_alert_success(
          "Absolute change in function value < {tolerance}"
        )
      }
      break
    }
    if (i == iterations_max && verbose) {
      cli::cli_h3("Termination")
      cli::cli_alert_warning("Iteration limit of {iterations_max} reached")
    }

    ### new start values
    current_initial <- step$parameter
    current_value <- step$value
  }

  ### return
  structure(
    out,
    class = c("trackopt", class(out)),
    objective = objective,
    npar = npar
  )
}

test_that("one-dim nlm track works", {
  f <- function(x) 5*x^4 + 4*x^3 + x^2 + 3*x + 2
  gradient <- function(x) 20*x^3 + 12*x^2 + 2*x + 3
  hessian <- function(x) matrix(60*x^2 + 24*x + 2, 1, 1)
  track <- nlm_track(f = f, p = 2, gradient = gradient, hessian = hessian)
  checkmate::expect_tibble(track, ncols = 7)
  checkmate::expect_class(summary(track), "summary.trackopt")
  checkmate::expect_class(invisible(autoplot(track)), "ggplot")
})

test_that("two-dim nlm track works", {
  himmelblau <- function(x) (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
  oeli::quiet(
    track <- nlm_track(f = himmelblau, p = c(0, 0), verbose = TRUE)
  )
  checkmate::expect_tibble(track, ncols = 7)
  checkmate::expect_class(summary(track), "summary.trackopt")
  checkmate::expect_class(invisible(autoplot(track)), "ggplot")
})

test_that("deals gracefully with errors", {
  f <- function(x) {
    if (x < -1) stop("my error")
    x
  }
  expect_warning(
    track <- nlm_track(f = f, p = 2, minimize = TRUE),
    "Optimization failed: Function evaluation threw an error: my error"
  )
  checkmate::expect_tibble(track, ncols = 7)
  checkmate::expect_class(summary(track), "summary.trackopt")
  checkmate::expect_class(invisible(autoplot(track)), "ggplot")
})

#' @inherit nlm_track examples
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
#' @importFrom checkmate check_class
#' @importFrom checkmate check_count
#' @importFrom checkmate check_flag
#' @importFrom checkmate check_function
#' @importFrom checkmate check_int
#' @importFrom checkmate check_integerish
#' @importFrom checkmate check_list
#' @importFrom checkmate check_number
#' @importFrom checkmate check_numeric
#' @importFrom checkmate check_tibble
#' @importFrom checkmate test_matrix
#' @importFrom checkmate test_number
#' @importFrom checkmate test_numeric
#' @importFrom cli cat_line
#' @importFrom cli cat_print
#' @importFrom cli cli_alert_info
#' @importFrom cli cli_alert_success
#' @importFrom cli cli_alert_warning
#' @importFrom cli cli_h1
#' @importFrom cli cli_h3
#' @importFrom cli cli_warn
#' @importFrom cli style_hyperlink
#' @importFrom ggplot2 aes
#' @importFrom ggplot2 autoplot
#' @importFrom ggplot2 geom_contour_filled
#' @importFrom ggplot2 geom_function
#' @importFrom ggplot2 geom_path
#' @importFrom ggplot2 geom_point
#' @importFrom ggplot2 ggplot
#' @importFrom ggplot2 labs
#' @importFrom ggplot2 scale_x_continuous
#' @importFrom ggplot2 scale_y_continuous
#' @importFrom oeli check_missing
#' @importFrom oeli check_numeric_vector
#' @importFrom oeli input_check_response
#' @importFrom optimizeR Objective
#' @importFrom optimizeR Optimizer
#' @importFrom stats nlm
#' @importFrom stats optim
#' @importFrom tibble tibble
#' @importFrom utils globalVariables
#' @importFrom utils packageVersion
## usethis namespace: end
NULL

#' @keywords internal

assign_to_cell <- function(tb, row, col, value) {
  if (length(value) == 1) {
    tb[row, col] <- value
  } else {
    if (col %in% colnames(tb) && !is.list(tb[[col]])) {
      tb[[col]] <- lapply(tb[[col]], identity)
    }
    tb[[row, col]] <- list(value)
  }
  tb
}

#' @keywords internal

.onAttach <- function(lib, pkg) {
  doc_link <- "https://loelschlaeger.de/trackopt"
  issues_link <- "https://github.com/loelschlaeger/trackopt/issues"
  msg <- c(
    paste0("This is {trackopt} ", utils::packageVersion("trackopt")),
    ", happy optimization tracking!\n",
    "Documentation? ",
    cli::style_hyperlink(doc_link, doc_link), "\n",
    "Any issues? ",
    cli::style_hyperlink(issues_link, issues_link)
  )
  packageStartupMessage(msg)
  invisible()
}

utils::globalVariables(c("parameter", "value", "x", "y", "z"))

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trackopt-package.R
\docType{package}
\name{trackopt-package}
\alias{trackopt}
\alias{trackopt-package}
\title{trackopt: Track Numerical Optimization}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

Tracks parameter values, gradients, and Hessians at each iteration of numerical optimizers. Useful for analyzing optimization progress, diagnosing issues, and studying convergence behavior.
}
\examples{
himmelblau <- function(x) {
  (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
}
track <- nlm_track(f = himmelblau, p = c(0, 0))
summary(track)
ggplot2::autoplot(track)
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/loelschlaeger/trackopt}
  \item Report bugs at \url{https://github.com/loelschlaeger/trackopt/issues}
}

}
\author{
\strong{Maintainer}: Lennart Oelschläger \email{oelschlaeger.lennart@gmail.com}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/nlm_track.R, R/optim_track.R,
%   R/trackopt_methods.R
\name{nlm_track}
\alias{nlm_track}
\alias{optim_track}
\alias{summary.trackopt}
\alias{autoplot.trackopt}
\title{Track numerical optimization}
\usage{
nlm_track(
  f,
  p,
  target = NULL,
  npar = NULL,
  gradient = NULL,
  hessian = NULL,
  ...,
  iterations_max = 100,
  tolerance = 1e-06,
  typsize = rep(1, length(p)),
  fscale = 1,
  ndigit = 12,
  stepmax = max(1000 * sqrt(sum((p/typsize)^2)), 1000),
  steptol = 1e-06,
  minimize = TRUE,
  verbose = FALSE
)

optim_track(
  f,
  p,
  target = NULL,
  npar = NULL,
  gradient = NULL,
  ...,
  iterations_max = 100,
  tolerance = 1e-06,
  lower = NULL,
  upper = NULL,
  method = c("Nelder-Mead", "BFGS", "CG", "L-BFGS-B", "SANN", "Brent"),
  control = list(),
  minimize = TRUE,
  verbose = FALSE
)

\method{summary}{trackopt}(object, ...)

\method{autoplot}{trackopt}(object, iteration = NULL, xlim = NULL, xlim2 = NULL, ...)
}
\arguments{
\item{f}{[\code{function}]\cr
A \code{function} to optimize. It must return a single \code{numeric} value.

By default, the first argument of \code{f} is optimized. That argument should
be a \code{numeric} vector of the same length as \code{p}. Additional arguments can
be supplied through \code{...}.

Use \code{target} when \code{f} should be optimized over another argument or over
multiple arguments.}

\item{p}{[\code{numeric()}]\cr
The starting parameter values for the target argument(s).}

\item{target}{[\code{character()} | \code{NULL}]\cr
The names of the numeric argument(s) to optimize.

If \code{NULL} (default), the first argument of \code{f} is used.}

\item{npar}{[\code{integer()}]\cr
The length of each target argument.

Specify \code{npar} when optimizing over multiple target arguments so \code{p} can
be split correctly.

If \code{target} contains a single argument and \code{npar} is \code{NULL}, \code{length(p)}
is used.}

\item{gradient}{[\code{function} | \code{NULL}]\cr
Optionally a \code{function} that returns the gradient of \code{f}.

Its arguments must match the arguments of \code{f}.}

\item{hessian}{[\code{function} | \code{NULL}]\cr
Optionally a \code{function} that returns the Hessian of \code{f}.

Its arguments must match the arguments of \code{f}.}

\item{...}{Additional arguments passed to \code{f}, and to \code{gradient} and \code{hessian} when
they are specified.}

\item{iterations_max}{[\code{integer(1)}]\cr
The maximum number of tracked optimization steps before termination.}

\item{tolerance}{[\code{numeric(1)}]\cr
Tracking stops when the absolute change in function value between two
consecutive iterations is less than this value.}

\item{typsize, fscale, ndigit, stepmax, steptol}{Arguments passed on to \code{\link[stats]{nlm}}.}

\item{minimize}{[\code{logical(1)}]\cr
If \code{TRUE}, minimize \code{f}; otherwise maximize it.}

\item{verbose}{[\code{logical(1)}]\cr
If \code{TRUE}, print progress after each iteration.}

\item{lower, upper}{[\code{numeric()} | \code{NULL}]\cr
Optional lower and upper parameter bounds. Scalars are recycled to the
number of parameters.}

\item{method, control}{Arguments passed on to \code{\link[stats]{optim}}.

Elements \code{trace} and \code{maxit} are ignored in \code{control} because
\code{optim_track()} controls tracing and iteration limits directly.}

\item{object}{[\code{trackopt}]\cr
A \code{trackopt} object.}

\item{iteration}{[\code{integer(1)}]\cr
The iteration to plot.

If \code{NULL}, the last iteration is plotted.

This option is useful for creating animations with the R Markdown
\code{animation} chunk option.}

\item{xlim, xlim2}{[\code{numeric(2)}]\cr
Ranges for the first and second parameter to plot.

If \code{NULL}, they are derived from the parameter ranges in \code{object}.}
}
\value{
A \code{tibble} with one row per stored iteration, including the starting point.
}
\description{
\itemize{
\item \code{nlm_track()}: track \code{\link[stats]{nlm}} iterations
\item \code{optim_track()}: track \code{\link[stats]{optim}} iterations
\item \code{summary()}: summarize an optimization track
\item \code{autoplot()}: visualize a track with one or two parameters
}
}
\examples{
himmelblau <- function(x) {
  (x[1]^2 + x[2] - 11)^2 + (x[1] + x[2]^2 - 7)^2
}
track <- nlm_track(f = himmelblau, p = c(0, 0))
summary(track)
ggplot2::autoplot(track)
}
